
; Thanks to Reverend for integer/float/ascii conversion examples

;=====================================================================
ascii_to_integer:
; in ---  [ebx] -> end of ascii string
; out --  edx  -> desired number

    xor    edx,edx
    xor    ecx,ecx
  .again:
    movzx  eax,byte[ebx]
    sub    al,'0'
    cwde
    push   edx
    mul    dword[convert_muler+ecx]
    pop    edx
    add    edx,eax
    dec    ebx
    cmp    byte[ebx],'0'
    jb     .end
    cmp    byte[ebx],'9'
    ja     .end
    add    ecx,4
    jmp    .again
  @@:
  .end:
ret

;===============================================================================
;       ASCII to float conversion procedure
;
;       input:
;       esi - pointer to string
;
;       output:
;       st0 - number changed into float
;       Reverend - thanks for effort!!
;===============================================================================
proc    atof
        local   .string  dd  ?
        push    eax ecx esi
        mov     [.string],esi
        fninit
        fldz
        fldz

        cld
        cmp     byte [esi], '-'
        jnz     @F
        inc     esi
    @@:
        xor     eax, eax
        align   4
  .loop.integer_part:
        lodsb
        cmp     al, '.'
        jz      .mantisa
        cmp     al,'0'
        jb      .exit
        cmp     al,'9'
        ja      .exit
        fimul   [i10]
        sub     al, '0'
        push    eax
        fiadd   dword [esp]
        add     esp, 4
        jmp     .loop.integer_part

  .mantisa:
        xor      ecx, ecx
        xor      eax, eax
        cld
        fxch     st1
     @@:

        lodsb
        cmp     al,'0'
        jb      .exit
        cmp     al,'9'
        ja      .exit
        cmp     ecx,7*4
        je      .exit           ; max 7 digits in mantisa
        sub     al,'0'
        push    eax
        fild    dword[esp]
        fidiv   dword[convert_muler+4+ecx]
        faddp
        add     esp,4
        add     ecx,4
        jmp     @b
  .exit:
        faddp

        mov     eax, [.string]
        cmp     byte [eax], '-'
        jnz     @F
        fchs
    @@:
        cld
        stc                             ; always returns no error
        pop     esi ecx eax
        ret

endp
;==============================================================================
itoa:              ; unsigned dword integer to ascii procedure
;     in   eax - variable
;          esi - Pointer to ascii string
;   out    esi - desired ascii string
;          edi - end of ascii string  - ptr to memory
 .temp_string  equ dword[ebp-36]
 .ptr          equ dword[ebp-40]
 .var          equ dword[ebp-44]
           push  ecx
           push  ebp
           mov   ebp,esp
           sub   esp,64
           mov   .var,eax
           or    eax,-1
           lea   edi,.temp_string
           cld
           mov   ecx,9
           rep   stosd      ; make floor


           mov   .ptr,esi
           lea   edi,.temp_string
           add   edi,34
           std
           xor   eax,eax
           stosb               ; mark begin
           mov   eax,.var
           mov   esi,10
        @@:
           xor   edx,edx
           div   esi
           xchg  eax,edx
           add   al,'0'
           stosb
           xchg  eax,edx
           or    eax,eax
           jnz   @b
           stosb                     ; mark end

           lea   esi,.temp_string
           cld
        @@:
           lodsb
           or   al,al
           jnz  @b

           mov  edi,.ptr
         @@:
           lodsb
           stosb
           or   al,al
           jnz  @b

           mov  esp,ebp
           pop  ebp
           pop  ecx
ret
;=================================================================

ftoa:
;   in  :  esi - pointer to  dword float
;          edi - pointer to ascii string
;          ecx - max digits in fraction
  .ptr_f     equ dword[ebp-4]
  .sign      equ dword[ebp-8]   ;  0 ->   less than zero, 1 - otherwise
  .ptr_ascii equ dword[ebp-12]
  .integer   equ dword[ebp-20]
  .fraction  equ dword[ebp-28]
  .status_orginal equ  word[ebp-32]
  .status_changed equ  word[ebp-34]
  .max_dig        equ dword[ebp-38]

         push     ecx
         push     ebp
         mov      ebp,esp
         sub      esp,64

        mov      .max_dig,ecx
        fninit
        fnstcw   .status_orginal
        mov      ax, .status_orginal
        or       ax, 0000110000000000b
        mov      .status_changed, ax
        fldcw    .status_changed
;       --------------------------------
;       check if signed
        xor      eax, eax
        fld      dword[esi]
        fst      .sign
        test     .sign, 80000000h
        setz     al
        mov      .sign, eax
        or       eax,eax
        jnz      @f
        inc      edi
       @@:

         mov       .ptr_f,esi
         mov       .ptr_ascii,edi
         fabs
         fld       st0
         frndint
         fist      .integer
         fsubp     st1, st0

         mov       eax,.integer
         mov       esi,.ptr_ascii
         call      itoa
      ;  edi   ->   ptr to end of ascii string
         dec       edi
         mov       al,'.'
         stosb

        mov     ecx,.max_dig  ; max 6 digits in fraction part
    .loop:
        fimul   [i10]
        fld     st0
        frndint
        fist    .fraction
        fsubp   st1, st0
        mov     esi,edi
        mov     eax,.fraction
        add     al,'0'
        stosb
        ftst
        fnstsw  ax
        test    ax, 0100000000000000b
        jz      @F
        test    ax, 0000010100000000b
        jz      .finish
    @@:
        loop    .loop
 .finish:
         ffree st
         cmp       .sign,0
         jnz       @f
         mov       esi,.ptr_ascii
         dec       esi
         mov       byte[esi],'-'
       @@:
         mov       esp,ebp
         pop       ebp
         pop       ecx

ret




;======================================================================

;=======================================================================
