
;***************************************
;* procs_b.inc file. Some procedures  **
;***************************************

;==========================================================
make_series:
;  clone/copy current  object
    push        ebp
    mov         ebp,esp
    sub         esp,28

    .p_ptr               equ [ebp-28]
    .tris_ptr            equ [ebp-24]
    .points_count_var    equ dword[ebp-20]
    .triangles_count_var equ dword[ebp-16]
    .points_r_ptr        equ dword[ebp-12]
    .triangles_ptr       equ dword[ebp-8]
    .points_rotated_ptr  equ dword[ebp-4]

     lea   edi,.points_count_var
     lea   esi,[points_count_var]
     cld
     movsd
     movsd
     movsd
     movsd
     movsd

    mov         ebx,.points_count_var
    lea         ebx,[ebx*3]
    shl         ebx,3
    add         ebx,1000
    malloc      ebx
    mov         .p_ptr,eax

    mov         ebx,.triangles_count_var
    lea         ebx,[ebx*3]
    shl         ebx,3
    add         ebx,1000
    malloc      ebx
    mov         .tris_ptr,eax
    mov         edi,eax
    mov         esi,.triangles_ptr
    mov         ecx,.triangles_count_var
    lea         ecx,[ecx*3]
    push        ecx
    push        esi
    cld
    rep         movsd
    pop         esi
    pop         ecx
    mov         edx,.points_count_var    ; make tris copy
   @@:
    lodsd
    add         eax,edx
    stosd
    loop        @b
    movzx       ebx,[tolerancy_flag]
    cvtsi2ss    xmm6,ebx
    mulss       xmm6,[scale]
    mov         eax,0.3
    movd        xmm7,eax
    mulss       xmm7,xmm6
    mov         ecx,.points_count_var
    push        ecx
    lea         ecx,[ecx*3]
    mov         esi,.points_rotated_ptr
    push        esi
    mov         edi,.p_ptr
    rep         movsd
    pop         esi
    pop         ecx
  .b1qq:
    lodsd
    movd        xmm0,eax
    addps       xmm0,xmm7
    movd        eax,xmm0
    stosd
    movsd
    movsd
    loop        .b1qq

    mfree       [points_r_ptr]
    mfree       [triangles_ptr]

    mov         eax,[points_count_var]
    add         eax,eax
    mov         [points_count_var],eax
    mov         eax,[triangles_count_var]
    add         eax,eax
    mov         [triangles_count_var],eax

    mov         ebx,.p_ptr
    mov         edx,.tris_ptr
    mov         [points_r_ptr],ebx
    mov         [triangles_ptr],edx

    mov         esp,ebp
    pop         ebp
ret

;============================================================
calc_combo:
    push    ebp
    mov     ebp,esp
    ; Calc all parameters - only triangles list and points list are provided as input.
    ; I want do some pre calculation (chunks, non tri rem, normals bumps/texture
    ; calcs ) quick and simply after all editing routines.
    ; Main goal is unify calculations and prevent bugs, wich causes variety of sub
    ; calculation options.
    .mem_sign equ dword [ebp-4]
    .tri_ch   equ [ebp-8]
    .t_ptr    equ [ebp-12]

     push     eax
     call     remove_non_tri
     mov      eax,[triangles_ptr]
     mov      ebx,[points_r_ptr]
     mov      ecx,[triangles_count_var]
     mov      edx,[points_count_var]
     call     remove_unused_verticesB
     mov      [points_count_var],ecx
     cmp      .mem_sign,'firs'
     je       .no_mem_work
     mov      eax,33       ; not free tri and vert
     call     free_mem_for_tp
     xor      eax,eax      ; not alloc for tri and vert
     call     alloc_mem_for_tp
 .no_mem_work:
     push     dword [points_r_ptr]
     push     [points_count_var]
     call     normalize_object1
     call     init_triangles_normals
     call     init_point_normals
     call     do_edges_list_ch
     mov      eax,[tex_scale]
     call     calc_bumpmap_coords
     mov      esp,ebp
     pop      ebp
ret

;========================================================================
if 0
aabb_inter:  ; axis aligned bounding box intersection
; in:
;       xmm0 - ray direction
;       xmm1 - ray origin
;       xmm2 - box min x,y,z
;       xmm3 - box max x,y,z
; out:
;       eax = 0 -> ray intersects box
;       eax = 0xffffff -> no intersection
      push    ebp
      mov     ebp,esp
      and     ebp,-16
      sub     esp,120

       .dir     equ [ebp-16]
       .dirz    equ [ebp-8]
       .origin  equ [ebp-32]
       .box_min equ [ebp-48]
       .box_max equ [ebp-64]

       .tmin    equ [ebp-80]
       .tymin   equ [ebp-76]
       .tzmin   equ [ebp-72]

       .tmax    equ [ebp-96]
       .tymax   equ [ebp-92]
       .tzmax   equ [ebp-88]


       rcpps    xmm7,xmm0
       movaps   .box_min,xmm2
       movaps   .box_max,xmm3
       movaps   .dir,xmm0
       movaps   .origin,xmm1
       movaps   xmm6,xmm2
       movaps   xmm5,xmm3
       subps    xmm6,xmm0
       subps    xmm5,xmm0
       mulps    xmm6,xmm7    ; xmm6 -  min
       mulps    xmm5,xmm7    ; xmm5  - max
       movaps   xmm0,xmm6
       minps    xmm6,xmm5
       maxps    xmm5,xmm0
       movaps   .tmin,xmm6
       movaps   .tmax,xmm5    ;  cmpnltss
       cmpnltss xmm6,.tymax  ;tmin > tymax ; 11 if grt
       cmpless  xmm5,.tymin  ;tmax <= tymin ; 11 if grt
       orps     xmm6,xmm5
;       movd    eax,xmm6
;       or      eax,eax
;       jnz     @f            ; false

       movss   xmm0,.tmin
       movss   xmm1,.tmax
       maxss   xmm0,.tymin
       minss   xmm1,.tymax

       cmpnltss xmm0,.tzmax  ; tmin >  tzmax
       cmpless  xmm1,.tzmin  ; tmax <= tzmin
       orps    xmm0,xmm1
       orps    xmm0,xmm6
       movd    eax,xmm0

       add     esp,120
       pop     ebp
ret
end if
;==========================================================================
intersect_tri: ; Moeller-Trumbore method
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;        xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...
      push    ebp
      mov     ebp,esp
      and     ebp,-16
      sub     esp,280
      sub     ebp,128      ; make shorter locals adreses

       .dir    equ [ebp-16]
       .origin equ [ebp-32]
       .ta     equ [ebp-48]
       .tb     equ [ebp-64]
       .tc     equ [ebp-80]
       .tvec   equ [ebp-96]
       .pvec   equ [ebp-112]
       .qvec   equ [ebp-128]
       .e1     equ [ebp]
       .ift    equ dword[ebp+16]
       .invdet equ [ebp+20]
       .det    equ [ebp+24]
       .ed_l   equ [ebp+28]
       .u      equ [ebp+40]
       .v      equ [ebp+36]
       .t      equ [ebp+32]
       .e2        equ [ebp+48]
       .zero_hgst equ [ebp+64]
       .eps       equ [ebp+80] ;  \
       .epsminus  equ [ebp+84] ;  |    dont change order
       .epsone    equ [ebp+88] ;  /
       .cross_a   equ dword[ebp+96]

      movups    xmm7,[eps_inter]
      mov       .cross_a,cross_aligned
      movaps    .eps,xmm7
      movaps    xmm7,[zero_hgst]
      movaps   .dir,xmm0
      movaps   .origin,xmm1
      movaps   .ta,xmm2
      movaps   .tb,xmm3
      movaps   .tc,xmm4
      movaps    .zero_hgst,xmm7
      mov      .ift,eax
      movss    .ed_l,xmm6
      subps    xmm3,xmm2
      subps    xmm4,xmm2
      andps    xmm3,xmm7
      andps    xmm4,xmm7
      movaps   .e1,xmm3
      movaps   .e2,xmm4
      lea      esi,.dir
      lea      edi,.e2
      lea      ebx,.pvec
      call     .cross_a
      movaps   xmm0,.e1
      mulps    xmm0,.pvec
 ;     andps    xmm0,[zero_hgst_dd]
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
   ;   dpps     xmm0,.pvec,01110111b
      movss    .det,xmm0
      comiss   xmm0,.eps
      jl       @f

      rcpss    xmm0,.det
      movss    .invdet,xmm0
      movaps   xmm0,.origin
      subps    xmm0,.ta
      andps    xmm0,.zero_hgst
      movaps   .tvec,xmm0
      mulps    xmm0,.pvec
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
   ;   dpps     xmm0,.pvec,01110111b
      mulss    xmm0,.invdet
      movss    xmm1,xmm0
      movss    .u,xmm0
      cmpnless xmm1,.epsone
      cmpnless xmm0,[epsminus]
      xorps     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f

      lea      esi,.tvec
      lea      edi,.e1
      lea      ebx,.qvec
      call     .cross_a
      movaps   xmm0,.dir
      mulps    xmm0,.qvec
   ;
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
   ;   int3
   ;   dpps     xmm0,.qvec,01110111b
      mulss    xmm0,.invdet
      movss    .v,xmm0
      movss    xmm1,xmm0
      addss    xmm1,.u
      cmpnless xmm1,.epsone
      cmpnless xmm0,.epsminus
      xorps     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f
      movaps   xmm1,.e2
      mulps    xmm1,.qvec
      haddps   xmm1,xmm1
      haddps   xmm1,xmm1
      mulss    xmm1,.invdet
      movss    .t,xmm1
      comiss   xmm1,.eps
      jl       @f
      xor      ebx,ebx
      mov      eax,1
      cmp      .ift,ebx
      je       .end       ; ok intersect occured, no edge cause
      movss    xmm0,.t      ; else check with edge lenght
      cmpnless xmm0,.eps
      cmpnless xmm1,.ed_l
      xorps    xmm0,xmm1
      movd     ebx,xmm0
      or       ebx,ebx
      jz       @f
      jmp      .end
   @@:
      xor      eax,eax
    .end:
      movaps   xmm0,.t
      add      esp,280
      pop      ebp
ret
;====================================================================
;====================================================================
mark_colided_edges:
; Proc has function of smothing inside edges also.
;   if eax = 1,2 smooth inside edges chose method

   push    eax

   or     eax,eax
   jne     @f
   prompt  prompt_det_coll_ed  ; macro
   jmp     .f
  @@:
   prompt  prompt_smooth_in_ed
  .f:
   mov     [thread_params+4],eax
   mov     ebx,[points_count_var]
   add     ebx,80
   imul    ebx,12
   malloc  ebx

   mov     [thread_params],eax
   mov     edi,eax
   mov     ecx,[points_count_var]
   lea     ecx,[ecx*3]
   mov     eax,-1
   cld
   rep     stosd


   mov      eax,mark_colided_edges_th
   xor      edx,edx
   mov      ecx,-1
   call     call_thread


     mov     esi,[thread_params]
     mov     edi,[points_r_ptr]
     cld
     mov     ecx,[points_count_var]
   .update:
     cmp     [esi],dword -1
     je      @f
     movsd
     movsd
     movsd
     loop   .update
     jmp    .en_u
   @@:
     add     esi,12
     add     edi,12
     loop    .update

   .en_u:

     pop    eax
     cmp    eax,1
     je     .skip_cnt  ; smooth ins edges cause

    mov    ecx,[edges_count]
    shr    ecx,3
    inc    ecx
    mov    esi,[edges_intersect_ptr]
    xor    ebx,ebx
   .pop_count:
    push   ecx
    xor    ecx,ecx
   @@:
    mov    eax,[esi]
    shr    eax,cl
    and    eax,1b
    add    ebx,eax
    inc    ecx
    cmp    ecx,8
    jne    @b
    inc    esi
    pop    ecx
    loop   .pop_count
    mov    [edges_coll_count],ebx

   .skip_cnt:
     mfree  dword[thread_params]

    cls   ; macro

ret
;==================================================================
mark_colided_edges_th:
;in: - some globals
;      dword[thread_params]   - ptr to modified vertices list
;      dword[thread_params+4] = 1 -> smooth ins ed, = 2 -> smooth ed
;                             inside vertices algo, otherwise mark
;                             collided edges
;      [thread_params+8]     - pointers to edges list adress
;      [thread_params+16]    - pointers to edges list adress
;      eax - thread No  // I may xchg thread_params mem area into stack area !!
;      [thread_params+16 + eax * 12] - edge adress off ptrs according to curr thread
;      [thread_params+20 + eax * 12] - edge mask according to curr thread
;      [thread_params+24 + eax * 12] - edge count according to curr thread
;      [thread_params+28+92 + eax * 12] - tris adress off ptrs according to curr thread
;      [thread_params+32+92 + eax * 12] - tris mask according to curr thread
;      [thread_params+36+92 + eax * 12] - tris count according to curr thread
;      [edges_intersect_ptr] - colided tri list, each tri as bit,
;      each colided edge marked as 1, otherwise -> 0
;      [inner_vert_ptr]- inside vertices mask list, each as bit, if set - outside
;      [thread_params+8]
   push    ebp
   mov     ebp,esp
   sub     esp,316
   and     ebp,-16
   sub     ebp,160

   .th_No        equ dword[ebp-4]
   .tri_cnt      equ dword[ebp-8]
   .smooth_ed    equ dword[ebp-12]
   .EdLen        equ dword[ebp-16]
   .edStart      equ [ebp-20]
   .edEnd        equ [ebp-24]
   .vy           equ [ebp-28]
   .vx           equ [ebp-32]

   ; triangles coords (vertices)

   .p2t          equ [ebp-48]
   .p3t          equ [ebp-64]
   .vertEd1      equ [ebp-80]
   .vertEd2      equ [ebp-96]
   .indexEd1     equ [ebp-112]
   .indexEd2     equ [ebp-128]

   .p1t          equ [ebp]
   .tri_norm     equ [ebp+16]
   .value        equ [ebp+32]
   .normEd       equ [ebp+64]
   .t                           equ [ebp+80]
   .inner_vert_ptr              equ dword[ebp+96]
   .intersect_tri               equ dword[ebp+100]

   .points_count_var            equ dword[ebp+104]
   .triangles_count_var         equ dword[ebp+108]
   .points_r_ptr                equ dword[ebp+112]
   .triangles_ptr               equ dword[ebp+116]
   .points_rotated_ptr          equ dword[ebp+120]
   .points_normals_rotated_ptr  equ dword[ebp+124]
   .edges_ptr                   equ dword[ebp+128]
   .edges_count                 equ dword[ebp+132]
   .ed_ptr                      equ [ebp+136]
   .edMsk                       equ [ebp+136]
   .edCnt                       equ dword[ebp+140]
   .tri_ptr                     equ [ebp+136]
   .triMsk                      equ dword[ebp+144]
   .triCnt                      equ dword[ebp+148]


   cld
   lea     esi,[points_count_var]
   lea     edi,.points_count_var
   mov     ecx,8
   rep     movsd
;   movaps  xmm7,[zero_hgst]
;   movaps  .zer_hgst,xmm7
   mov     .intersect_tri,intersect_tri
   push    [inner_vert_ptr]
   pop     .inner_vert_ptr
   mov     eax,ebx
   mov     edx,0.008889
   movd    xmm0,edx
   shufps  xmm0,xmm0,0
   movaps  .value,xmm0    ; margin value

if 0
      ; calc reversed teslate area

   mov      esi,matrix_scaled            ; check if in tes area
   lea      edi,[.mxx]                   ; only using indexes
   call     reverse_mx_3x3               ; not reverse tes area
   cvtdq2ps xmm3,[xxadd]
   movlhps  xmm3,xmm3
   movaps   xmm0,[tri_area_x1]
   subps    xmm0,xmm3
   movlps   [.ar_rev1],xmm0
   movhps   [.ar_rev1+12],xmm0
   xor      eax,eax
   mov      [.ar_rev1+8],eax    ; zero 'z'
   mov      [.ar_rev2+8],eax
   lea      esi,[.ar_rev1]
   lea      edi,[.ar_rev2]
   mov      ecx,2
   call     rotary
   movlps   xmm0,[.ar_rev2]
   movhps   xmm0,[.ar_rev2+12]
    ;.ar_rev2  - reversed tes area

end if

   mov     .smooth_ed,ebx
   mov     .th_No,eax

   mov     ebx,.edges_count
   mov     ecx,ebx
   shr     ebx,2
   and     ecx,11b
   imul    eax,ebx
   mov     .edStart,eax
   add     eax,ebx
   cmp     .th_No,3
   jnz     @f
   add     eax,ecx
 @@:
   mov     .edEnd,eax
   mov     esi,.edges_ptr
   mov     ebx,.edStart
   shl     ebx,3
   add     esi,ebx
   mov     ecx,.edStart
 .nx_ed:   ; next edge

   push    ecx
   cld
 ;  movlps  xmm0,[esi]
 ;  movlps  xmm1,[esi]
   lodsd
   xchg    eax,ebx
   lodsd
   push    esi
   lea     edi,.indexEd2
   stosd
   stosd
   stosd
   stosd
   xchg    ebx,eax
   stosd
   stosd
   stosd
   stosd
   xchg    eax,ebx
 ;  shufps  xmm0,xmm0,0
 ;  shufps  xmm1,xmm1,01010101b
   pcmpeqd xmm7,xmm7
 ;  movaps  .indexEd1,xmm0
 ;  movaps  .indexEd2,xmm1
 ;  int3
   imul    eax,12
   imul    ebx,12
   mov     edi,.points_r_ptr
   psrldq  xmm7,4
   movups  xmm1,[ebx+edi]
   movups  xmm2,[eax+edi]
   andps   xmm2,xmm7 ;.zer_hgst
   andps   xmm1,xmm7 ;.zer_hgst
   movaps  .vertEd1,xmm2
   movaps  .vertEd2,xmm1
   subps   xmm2,xmm1
   movaps  xmm3,xmm2
   mulps   xmm2,xmm2
   haddps  xmm2,xmm2
   haddps  xmm2,xmm2
   sqrtps  xmm2,xmm2
   movss   .EdLen,xmm2
   rcpps   xmm2,xmm2
   mulps   xmm3,xmm2
   andps   xmm3,xmm7 ;[zer_hgst]
   movaps  .normEd,xmm3
   mov     edi,.triangles_ptr
   xor     eax,eax
   mov     .tri_cnt,eax





 .nx_tri:  ; next triangle
   push    edi
   push    esi
   mov     esi,edi
   cld

   lodsd
   xchg    eax,edx
   lodsd
   xchg    eax,ebx
   lodsd
   xchg    eax,edx
   mov     esi,.points_r_ptr
   imul    eax,12
   imul    ebx,12
   imul    edx,12

   movups  xmm6,[eax+esi]   ; .p1t  =  tri 1st vertex
   movups  xmm3,[ebx+esi]   ; .p2t
   movups  xmm4,[edx+esi]   ; .p3t
   movaps  xmm2,xmm6

   maxps   xmm2,xmm3
   maxps   xmm2,xmm4
   minps   xmm3,xmm4
   minps   xmm3,xmm6

   movaps  xmm4,.vertEd1
   movaps  xmm1,.vertEd2
   maxps   xmm4,xmm1
   cmpltps xmm4,xmm3
   minps   xmm1,.vertEd1
   cmpltps xmm1,xmm2
   xorps   xmm1,xmm4
   movmskps eax,xmm1
   or       eax,eax
   jnz      .chck
 .fff:

   inc     .triCnt
 .end_l_tri:
   pop      esi
   pop      edi
   add      edi,12
   inc      .tri_cnt
   mov      edx,.tri_cnt
   cmp      edx,.triangles_count_var
 ;  loop    .nx_ed
   jnz     .nx_tri
 .nx_loop_end:
   pop      esi
   pop      ecx
   inc      ecx
   cmp      ecx,.edEnd
   jne      .nx_ed
   jmp      .end

;intersect_tri: procs header
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;        xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...
; @@:
 .chck:
;  xchg    esi,edi
   movups  xmm0,[edi]
   movups  xmm1,[edi]
 ;  movaps  xmm3,.indexEd1
 ;  movaps  xmm4,.indexEd2
 ;  shufps  xmm3,xmm3,0
 ;  shufps  xmm4,xmm4,01010101b

   pcmpeqd xmm0,.indexEd1
   pcmpeqd xmm1,.indexEd2
;   movaps  .indexEd1,xmm3
;   movaps  .indexEd2,xmm4
   orps    xmm1,xmm0
;  xchg    esi,edi
   cld
   movmskps eax,xmm1
   and     eax,111b
   or      eax,eax
   jnz     .end_l_tri

   movups   xmm2,xmm6 ;[eax+esi]  ; .p1t
   movups   xmm3,[ebx+esi]        ; .p2t
   movups   xmm4,[edx+esi]        ; .p3t
   movups   .p1t,xmm2
   movups   .p2t,xmm3
   movups   .p3t,xmm4

;   movaps  xmm6,.vertEd1 ;,xmm2
;   movaps  xmm1,.vertEd2 ;,xmm1
;   subps   xmm6,xmm1
;   movaps  xmm0,xmm6
;   mulps   xmm6,xmm6
;   haddps  xmm6,xmm6
;   haddps  xmm6,xmm6
;   sqrtps  xmm6,xmm6
;   movss   .EdLen,xmm6
;   rcpps   xmm5,xmm6
;   mulps   xmm0,xmm5
;   andps   xmm0,[zero_hgst]
;   movaps  .normEd,xmm0

   movaps   xmm0,.normEd
   movaps   xmm1,.vertEd2

   movss    xmm6,.EdLen
   mov      eax,1
   call     .intersect_tri
   cmp      eax,1
   jne      .end_l_tri

 .inter:
 ;  [edi] - tri
 ;  [esi] - edge
   xor    eax,eax
   cmp    dword[thread_params+4],eax  ; no mark
   jne    @f
   mov    eax,ecx  ;.tri_cnt
   mov    ebx,ecx  ;.tri_cnt
   shr    eax,3
   and    ebx,111b
   add    eax,[edges_intersect_ptr]
   lock   bts   [eax],ebx
  @@:
   xor    eax,eax
   mov    ebx,[thread_params+4]
   cmp    ebx,eax
   je     .nx_end   ; check smooth inside edges cause
   cmp    ebx,2
   je     .sm_ins_vert  ; check smooth inside edges - inside vertices algo

   mov    ebx,.tri_cnt
   imul   ebx,12
   add    ebx,[triangles_normals_ptr]
   movups  xmm5,[ebx]
   movaps  .tri_norm,xmm5
   shufps  xmm0,xmm0,0  ; xmm0 - t
   mulps   xmm0,.normEd
   addps   xmm0,.vertEd2
  ; xmm0 -- intersection point coords
   movaps  xmm7,xmm0
   subps   xmm0,.vertEd1
   mulps   xmm0,.tri_norm
   haddps  xmm0,xmm0
   haddps  xmm0,xmm0 ; dot
   movmskps eax,xmm0
   movaps  xmm0,.normEd
   mulps   xmm0,.value ; remains margin value
   cmp     eax,0xf
   je      @f
   addps   xmm7,xmm0
   mov     ebx,.indexEd1
   jmp     .fix
  @@:
   mov     ebx,.indexEd2
   subps   xmm7,xmm0
  .fix:
   imul    ebx,12
   movhlps xmm6,xmm7
   add     ebx,[thread_params]
   movlps  [ebx],xmm7
   movss   [ebx+8],xmm6
   jmp     .nx_end

 .sm_ins_vert:


   movaps    .t,xmm0

   movss     xmm1,[the_one]
   subss     xmm1,.vx
   subss     xmm1,.vy
   movlps    xmm5,.vx
   movlps    xmm6,.vy
   shufps    xmm1,xmm1,0
   shufps    xmm5,xmm5,0
   shufps    xmm6,xmm6,0
   mulps     xmm1,.p1t
   mulps     xmm5,.p2t
   mulps     xmm6,.p3t
   addps     xmm1,xmm5
   addps     xmm1,xmm6
   mov       eax,.indexEd1  ; vertices indexes
   mov       edx,.indexEd2
   mov       esi,eax
   mov       edi,edx
   shr       esi,3
   shr       edi,3
   and       eax,111b
   and       edx,111b
   mov       ebx,.indexEd2
   add       esi,.inner_vert_ptr
   add       edi,.inner_vert_ptr
;  check if at last one vertex is inside
; if yes choose its index to ebx
   bt        [esi],eax
   jc        @f
   mov       ebx,.indexEd1
   jmp       .ddo
 @@:
   bt        [edi],edx
   jc        .nx_end
   mov       ebx,.indexEd2
 .ddo:
   imul      ebx,12
   add       ebx,.points_r_ptr

   movd      ecx,xmm1
   lock      xchg [ebx],ecx
   psrldq    xmm1,4              ; need test !!
   movd      ecx,xmm1
   lock      xchg [ebx+4],ecx
   psrldq    xmm1,4
   movd      ecx,xmm1
   lock      xchg [ebx+8],ecx

 .nx_end:
   pop    esi
   pop    edi
   jmp    .nx_loop_end
 .end:
;   mov  eax,.triCnt
;   int3
;   mov     ebx,.ed_coll_ptr
;   mov     ecx,.collEdCnt       ; Colided edges count

   add     esp,316
   pop     ebp
ret

;=============================================================
;=============================================================
;=============================================================

remove_non_tri:
  pushad
;  or      eax,-1
;  movd    xmm7,eax
;  shufps  xmm7,xmm7,0
  pcmpeqd xmm7,xmm7
  mov     esi,[triangles_ptr]
  mov     ecx,[triangles_count_var]
 .chck:
  jecxz   .cop
  mov     eax,[esi]
  cmp     eax,[esi+4]
  je      .tri_fail
  cmp     eax,[esi+8]
  je      .tri_fail
  mov     eax,[esi+4]
  cmp     eax,[esi+8]
  je      .tri_fail
  add     esi,12
  loop    .chck
  jmp     .cop
 .tri_fail:
  movlps  [esi],xmm7
  movd    [esi+8],xmm7
  add     esi,12
  loop    .chck
 .cop:
  mov     esi,[triangles_ptr]
  mov     edi,[triangles_ptr]
  mov     ecx,[triangles_count_var]
  xor     edx,edx
  cls
  or      eax,-1
 .cp:
  cmp     [esi],eax
  je      .ff
  movsd
  movsd
  movsd
  inc     edx
  loop    .cp
  jmp     .en_cp
 .ff:
  add     esi,12
  loop    .cp
 .en_cp:
  mov     [triangles_count_var],edx
  popad
ret
;============================================================
;====================================================================
do_variable_slices_ptr_buff:
; Procedure match every screen pixel with ptr, wich describes
; its depth history. If dword ptr = byte cnt = 0, not depth
; history, pixel has background color.
; in:  esi - counter buff
;      edi - ptr buff
;      eax - voxels depth history buff
;      ecx - count of all screen pixels
       jecxz  .end
       xor    ebx,ebx
     .again:
       movzx  edx,byte[esi]
       or     edx,edx
       jz     .zero
       mov    [edi],eax
       shl    edx,2
       add    eax,edx
       jmp    .u_cnts
     .zero:

       mov    [edi],ebx
     .u_cnts:
       inc    esi
       add    edi,4
       loop    .again
    .end:
ret
;================================================
count_transparent_voxels:     ; Thanks Agner Fog for optimiztion
                              ; phaddb on sse2   :D
; in:
;    edi - ptr to slices_cnt buffer
;          this buff describes how many
;          slices has every rendered pixel
;    eax - size x of screen
;    ebx - size y of scr
; out:
;    ecx - count of all transparent voxels

     push     ebp
     mul      ebx
     mov      ecx,eax
     and      eax,1111b
     shr      ecx,4
     xor      ebx,ebx
     xorps     xmm3,xmm3
  @@:
     movups   xmm1,[edi]
     xorps    xmm0,xmm0
     psadbw   xmm1,xmm0
     pshufd   xmm0,xmm1,0x0e
     paddd    xmm0,xmm1
     paddd    xmm3,xmm0
     add      edi,16
     loop     @b
     mov      ecx,eax
     jecxz    .en
   @@:
     movzx    eax,byte[edi]
     add      ebx,eax
     loop     @b
    .en:
     movd    ecx,xmm3
     add     ecx,ebx
     pop     ebp
ret

